Option Explicit

Sub Main()

' Declare all the variables
Dim sTextLine As String
Dim GarbageSkipped As Boolean
Dim StartCounting As Boolean
Dim StartTimeH As Long
Dim StartTimeM As Long
Dim StartTimeS As Long
Dim TotalTimeH As Long
Dim TotalTimeM As Long
Dim TotalTimeS As Long
Dim FoundTimeH As Long
Dim FoundTimeM As Long
Dim FoundTimeS As Long

' (Re)set all the variables
sTextLine = ""
GarbageSkipped = False
StartCounting = False
StartTimeH = 0
StartTimeM = 0
StartTimeS = 0
TotalTimeH = 0
TotalTimeM = 0
TotalTimeS = 0
FoundTimeH = 0
FoundTimeM = 0
FoundTimeS = 0

' Start the routine
Open "c:\test@hotmail.com.txt" For Input As #1
  ' Skip all lines until we have a .---. line (or until the end of file is reached)
  While Not EOF(1)
    ' Read a line
    Line Input #1, sTextLine
    ' Check if we have a .---. line
    ' Checking on the first or the second line like this is not needed (thus neither is skipping)
    If RTrim(sTextLine) = "." & String(68, "-") & "." Then
      ' We have found a .---. line...
      ' The next boolean will tell us if all lines before the first occurence of the .---. line were skipped
      ' Since sTextLine = ".---.", we can assume that they are.
      ' This boolean will remain True for the rest of the application.
      GarbageSkipped = True
      ' Now let's assume this is already the second line!!!
      ' This means that the next line should be a chatline and that timecalculating should start
      ' If it wasn't the second .---. line then no harm is done and the timecalculating still needs to start
      StartCounting = True
    End If
    ' Check if we have a chatline (and if all the garbage before the first session has been ignored).
    ' The following depends on how the timevalue is formatted of course.
    ' 24h and [00:00:00] is assumed in this example
    If (sTextLine Like "[[]##:##:##[]] ?*") And (GarbageSkipped = True) Then
      ' We have found a chatline, so grab the timevalue.
      FoundTimeH = Val(Mid(sTextLine, 2, 2))
      FoundTimeM = Val(Mid(sTextLine, 5, 2))
      FoundTimeS = Val(Mid(sTextLine, 8, 2))
      ' Check if this was the first chatline in a session.
      If StartCounting = True Then
        ' It was...
        ' All we need to do is reset the StartCounting check and
        ' assign the timevalue from where we start to calculate.
        StartCounting = False
        ' Note that by assigning the new found timevalue here, we will overwrite the old
        ' Starttime-values, even if no calculation has been done with them (this is the
        ' case if only 1 chatline exist in a session)
        StartTimeH = FoundTimeH   ' \
        StartTimeM = FoundTimeM   ' +--> See comments below
        StartTimeS = FoundTimeS   ' /
      Else
        ' It was not; a previous timevalue has already been assigned to StartTime.
        ' This means that the current found timevalue will be used to calculate
        ' the passed time since the previous timevalue/chatline.
        ' Calculate the passed time and add it to the total time in one go:
        TotalTimeH = TotalTimeH + FoundTimeH - StartTimeH
        TotalTimeM = TotalTimeM + FoundTimeM - StartTimeM
        TotalTimeS = TotalTimeS + FoundTimeS - StartTimeS
        ' If the current timevalue (FoundTime) is less then the previous one (StartTime),
        ' then a day has passed and we need to add 24h.
        If TimeSerial(FoundTimeH, FoundTimeM, FoundTimeS) < TimeSerial(StartTimeH, StartTimeM, StartTimeS) Then
          TotalTimeH = TotalTimeH + 24
        End If
        ' After all this, set the current timevalue as the starting value for the next
        ' possible calculation in case we find a new timevalue.
        StartTimeH = FoundTimeH   ' \
        StartTimeM = FoundTimeM   ' +--> See comments below
        StartTimeS = FoundTimeS   ' /
      End If
    End If
    ' You noticed that those three last lines in the IF.THEN.ELSE can be written here
    ' instead because they exist in both the "True" and "False" checks and do exactly
    ' the same (But for "simplicity" and to comment them, I left them above).
    '  StartTimeH = FoundTimeH   ' \
    '  StartTimeM = FoundTimeM   ' +--> See those two chuncks above
    '  StartTimeS = FoundTimeS   ' /
  Wend
Close #1

MsgBox "Total time chatted: " & _
       Format(TotalTimeH + TotalTimeM \ 60 + TotalTimeS \ 3600, "00:") & _
       Format((TotalTimeM + TotalTimeS \ 60) Mod 60, "00:") & _
       Format(TotalTimeS Mod 60, "00")

End Sub
